/*
  CPP_CONTEST=2012
  CPP_PROBLEM=A
  CPP_LANG=C+OPENMP+MPI
  CPP_NUM_CORES = 1
  CPP_PROCESSES_PER_NODE 1
 */

//swcond

#include <stdlib.h>
 
int unadistancia(int t,int *a,int numero)
{
  int i,j,cont=0;
  int d=0,dist,dc;
  int *filas,*columnas;

  filas=(int *) malloc(sizeof(int)*t*t);
  columnas=(int *) malloc(sizeof(int)*t*t);

  for(i=0;i<t;i++)
  {
    for(j=0;j<t;j++)
    {
      if(a[i*t+j]==numero)
      {
        filas[cont]=i;
        columnas[cont]=j;
        cont++;
      }
    }
  }
  
  for(i=0;i<cont;i++)
  {
    for(j=i+1;j<cont;j++)
    {  
      dist=filas[j]-filas[i];
      dc=columnas[i]-columnas[j];
      if(dc>0)
        dist+=dc;
      else
        dist-=dc;
      if(dist>d)
        d=dist;
    }
  }

  free(filas);
  free(columnas);

  return d;   
}
    
void distancia(int t,int *a,int n,int *numeros,int *distancias,int nodo,int np)
{
  int i;

  for(i=0;i<n;i++)
    distancias[i]=unadistancia(t,a,numeros[i]); 

}

